#!/usr/bin/env python
#----------------------------------------------------------------------
# File: train.py
# Description: example of kernel density estimation
# Created: 01-June-2013 INFN SOS 2013, Vietri sul Mare, Italy, HBP
#----------------------------------------------------------------------
import os, sys, re
from ROOT import *
from math import *
from string import *
from histutil import *
#----------------------------------------------------------------------
def buildKDE(ntuple, kde, name):
    point = vector('double')(2)
    count = 0
    for rownumber, event in enumerate(ntuple):
        if event.f_pt4l < 0: continue
        count += 1
        if count % 1000 == 0: print count
        point[0], point[1] = event.f_Z1mass, event.f_Z2mass
        kde.add(point)
        if count >= 3000: break
    kde.optimize()
    kde.write(name)
#----------------------------------------------------------------------
def main():
    print "\n", "="*80
    print "\t example of kernel density estimation"
    print "="*80

    # compile standalone KDE class
    gROOT.ProcessLine('.L KDE.cc+')
    bkde = KDE('mz1 mz2')
    skde = KDE('mz1 mz2')
    
    treename = "HZZ4LeptonsAnalysis"
    
    sfilename = 'sig_gg-H-ZZ-2e2mu_8TeV_126GeV.root'
    sntuple = Ntuple(sfilename, treename)
    buildKDE(sntuple, skde, 'skde')
    
    bfilename = 'bkg_ZZ-2e2mu_8TeV.root'
    bntuple = Ntuple(bfilename, treename)
    buildKDE(bntuple, bkde, 'bkde')
#----------------------------------------------------------------------
try:
    main()
except KeyboardInterrupt:
    print "\nciao"
